Index: LMDZ5/branches/testing/DefLists/config.def_IPSLCM5B_AGCM
===================================================================
--- LMDZ5/branches/testing/DefLists/config.def_IPSLCM5B_AGCM	(revision 1707)
+++ LMDZ5/branches/testing/DefLists/config.def_IPSLCM5B_AGCM	(revision 1750)
@@ -73,4 +73,7 @@
 # Parametres effets directs/indirects des "aerosols"
 #######################################
+### ok cloud droplet number concentration
+# n par defaut (sans aerosols), y avec aerosols
+ok_cdnc=y
 ### ok_ade=y/n   flag Aerosol direct effect
 ok_ade=y
@@ -79,5 +82,5 @@
 ### aer_type =   Aerosol variation type : actuel / preind / scenario / annuel
 aer_type=preind
-###  type of coupled aerosol =1 (default) =2 => bc  only =3 => pom only =4 => seasalt only =5 => dust only =6 => all aerosol
+###  If aerosol offline : type of coupled aerosol =0 (pas d aerosol) =1 (sulphate only default) =2 => bc  only =3 => pom only =4 => seasalt only =5 => dust only =6 => all aerosol
 flag_aerosol=6 
 ### bl95_b0 =    Parameter in CDNC-maer link (Boucher&Lohmann 1995)
Index: LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM
===================================================================
--- LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM	(revision 1707)
+++ LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM	(revision 1750)
@@ -72,4 +72,7 @@
 # Parametres effets directs/indirects des "aerosols"
 #######################################
+### ok cloud droplet number concentration
+# n par defaut (sans aerosols), y avec aerosols 
+ok_cdnc=y 
 ### ok_ade=y/n   flag Aerosol direct effect
 ok_ade=y
@@ -78,5 +81,5 @@
 ### aer_type =   Aerosol variation type : actuel / preind / scenario / annuel
 aer_type=actuel
-###  type of coupled aerosol =1 (default) =2 => bc  only =3 => pom only =4 => seasalt only =5 => dust only =6 => all aerosol
+###  If aerosol offline : type of coupled aerosol =0 (pas d aerosol) =1 (sulphate only default) =2 => bc  only =3 => pom only =4 => seasalt only =5 => dust only =6 => all aerosol 
 flag_aerosol=6 
 ### bl95_b0 =    Parameter in CDNC-maer link (Boucher&Lohmann 1995)
Index: LMDZ5/branches/testing/DefLists/gcm.def
===================================================================
--- LMDZ5/branches/testing/DefLists/gcm.def	(revision 1707)
+++ LMDZ5/branches/testing/DefLists/gcm.def	(revision 1750)
@@ -5,5 +5,5 @@
 iperiod=5
 ## periode de la dissipation (en pas)
-idissip=5
+## dissip_period=0
 ## choix de l'operateur de dissipation (star ou  non star )
 lstardis=y
Index: LMDZ5/branches/testing/arch/arch-X64_ADA.fcm
===================================================================
--- LMDZ5/branches/testing/arch/arch-X64_ADA.fcm	(revision 1707)
+++ LMDZ5/branches/testing/arch/arch-X64_ADA.fcm	(revision 1750)
@@ -3,14 +3,13 @@
 %AR                  ar
 %MAKE                gmake
-%FPP_FLAGS           -P -traditional
-%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM 
-%BASE_FFLAGS         -integer-size 32 -real-size 64 -align all 
-%PROD_FFLAGS         -O3 -ip 
+%FPP_FLAGS           -P -traditional -I/smplocal/pub/FFTW/3.3.3/include/
+%FPP_DEF             NC_DOUBLE BLAS SGEMV=DGEMV SGEMM=DGEMM FFT_FFTW
+%BASE_FFLAGS         -mcmodel=large -integer-size 32 -real-size 64 -align all 
+%PROD_FFLAGS         -O2 -ip -fp-model strict -axAVX,SSE4.2
 %DEV_FFLAGS          -p -g -O1 -fpe0 -traceback
-%DEBUG_FFLAGS        -p -g -O0 -no-ftz -traceback -ftrapuv -fp-stack-check -check -fpe0
+%DEBUG_FFLAGS        -p -g -O0 -fpe-all=0 -traceback -ftrapuv -fp-stack-check -check all -debug
 %MPI_FFLAGS
 %OMP_FFLAGS          -openmp
-%%%%BASE_LD             -lmkl_intel_lp64 -lmkl_sequential -lmkl_core
-%BASE_LD             -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -lpthread
+%BASE_LD             -shared-intel  -lmkl_intel_lp64 -lmkl_sequential -lmkl_core -lpthread -L/smplocal/pub/FFTW/3.3.3/lib -lfftw3
 %MPI_LD
 %OMP_LD              -openmp
Index: LMDZ5/branches/testing/arch/arch-X64_ADA.path
===================================================================
--- LMDZ5/branches/testing/arch/arch-X64_ADA.path	(revision 1707)
+++ LMDZ5/branches/testing/arch/arch-X64_ADA.path	(revision 1750)
@@ -1,3 +1,3 @@
-NETCDF_LIBDIR="${NETCDF_LDFLAGS:--L/smplocal/pub/NetCDF/4.1.3/lib -lnetcdff -lnetcdf}"
+NETCDF_LIBDIR="${NETCDF_LDFLAGS:--L/smplocal/pub/NetCDF/4.1.3/lib -lnetcdff -lnetcdf -L/smplocal/pub/HDF5/1.8.9/seq/lib -lhdf5hl_fortran -lhdf5_hl -lhdf5_fortran -lhdf5 -lz}"
 NETCDF_INCDIR="${NETCDF_FFLAGS:--I/smplocal/pub/HDF5/1.8.9/seq/include -I/smplocal/pub/NetCDF/4.1.3/include}"
 IOIPSL_INCDIR=$LMDGCM/../../lib
Index: LMDZ5/branches/testing/arch/arch-X64_CURIE.fcm
===================================================================
--- LMDZ5/branches/testing/arch/arch-X64_CURIE.fcm	(revision 1707)
+++ LMDZ5/branches/testing/arch/arch-X64_CURIE.fcm	(revision 1750)
@@ -7,5 +7,5 @@
 %BASE_FFLAGS         -i4 -r8 -auto -align all -I${MKLROOT}/include
 %PROD_FFLAGS         -O3
-%DEV_FFLAGS          -p -g -O2 -traceback -fp-stack-check -ftrapuv
+%DEV_FFLAGS          -p -g -O2 -traceback -fp-stack-check
 %DEBUG_FFLAGS        -p -g -traceback -fp-stack-check -ftrapuv
 %MPI_FFLAGS
Index: LMDZ5/branches/testing/beta_crf.data
===================================================================
--- LMDZ5/branches/testing/beta_crf.data	(revision 1750)
+++ LMDZ5/branches/testing/beta_crf.data	(revision 1750)
@@ -0,0 +1,8 @@
+70000. !pfree
+1.     !beta_pbl
+1.     !beta_free
+-180.  !lon1_beta
+180.   !lon2_beta
+90.    !lat1_beta
+-90    !lat2_beta
+.FALSE. !mskocean_beta
Index: LMDZ5/branches/testing/create_make_gcm
===================================================================
--- LMDZ5/branches/testing/create_make_gcm	(revision 1707)
+++ LMDZ5/branches/testing/create_make_gcm	(revision 1750)
@@ -4,4 +4,7 @@
 #
 #set -xv
+
+rm -f create_make_gcm.log
+
 machine=`hostname`
 os=`uname`
@@ -122,36 +125,30 @@
 echo
 cd $libf >/dev/null 2>&1
-for diri in ` ls `
-do
+
+for diri in ` ls ` ; do
+
    if [ -d $diri ] ; then
-   if [ "`ls $diri/*.F`" != "" ] || [ "`ls $diri/*.F90`" != "" ]  ; then 
-      cd $diri >/dev/null 2>&1
+   if [ "`ls $diri/*.F $diri/*/*.F`" != "" ] || [ "`ls $diri/*.F90 $diri/*/*.F90`" != "" ]  ; then 
+#      cd $diri >/dev/null 2>&1
       echo
       listlib=""
-      for i in `ls *.F`
-      do
-         fili=`basename $i .F`
-         test=` (  head $i | grep '      PROGRAM' ) `
-         if [ "$test" = "" ] ; then 
-            listlib=$listlib" "$fili
-         fi
-      done
-      for i in `ls *.F90`
-      do
-         fili=`basename $i .F90`
-         test=` (  head $i | grep '      PROGRAM' ) `
-         if [ "$test" = "" ] ; then
-            listlib=$listlib" "$fili
-         fi 
-      done
-#
-      echo
-      echo
-      echo "#======================================================================="
+# Liste des fichiers .F et .F90 n'etant pas des programmes principaux
+      for fili in `ls $diri/*.F $diri/*/*.F` ; do
+         test=` (  head $fili | grep '      PROGRAM' ) `
+         if [ "$test" = "" ] ; then listlib=$listlib" "$fili ; fi
+      done
+      for fili in `ls $diri/*.F90 $diri/*/*.F90` ; do
+         test=` (  head $fili | grep 'PROGRAM' ) `
+         if [ "$test" = "" ] ; then listlib=$listlib" "$fili ; fi 
+      done
+      echo
+      echo $listlib >> create_makeg_gcm.log
+      echo
+      echo "#=================================================================="
       echo "# Contenu de la bibliotheque correspondant au Directory "$diri
-      echo "#======================================================================="
-      echo
-      for fili in $listlib
-      do
+      echo "#=================================================================="
+      echo
+      for trufile in $listlib ; do
+         fili=`echo $trufile | awk -F/ ' { print $NF } ' | cut -d. -f1`
          echo '$(LIBO)/lib'$diri".a : " '$(LIBO)/lib'$diri".a("$fili".o)"
          echo
@@ -162,47 +159,46 @@
       echo "# Compilation des membres de la bibliotheque lib"$diri".a"
       echo
-      for fili in $listlib
-      do
-         if [ -f $fili.F90 ] ; then
-           trufile=$fili.F90
-         else
-           trufile=$fili.F
-         fi
+      for trufile in $listlib ; do
+         fili=`echo $trufile | awk -F/ ' { print $NF } ' | cut -d. -f1`
          F90=0 ; egrep -i '^ *use ' $trufile > /dev/null 2>&1 && F90=1
                  egrep -i '^ *module ' $trufile > /dev/null 2>&1 && F90=1
                  egrep -i '#include*.inc ' $trufile > /dev/null 2>&1 && F90=1
-         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$diri/$trufile
-         [ "$fili" = "chem.subs" ] && str1=$str1' $(LIBF)/'$diri/chem.mods.F
-         for stri in ` ( sed -n "/\#include/s/\#include//p" $trufile | sed 's/\"//g' ; egrep -i '^ *use ' $trufile | sed -e 's/,/ /' | awk ' { print $2 } ' ) `
-         do
-
-
+         str1='$(LIBO)/lib'$diri'.a('$fili'.o) : $(LIBF)/'$trufile
+         [ "$fili" = "$diri/chem.subs" ] && str1=$str1' $(LIBF)/'$diri/chem.mods.F
+
+##########################################################################
+# TRAITEMENT DES DEPENDANCES
 # Differents cas de dependance correspondant a des include ou des
 # use module.
 # soit dans le repertoire local soit dans un autre.
-
-            stri=`echo $stri | tr [A-Z] [a-z]`
-            if [ -f $stri ] ; then
+# Pour dyn3d, il faudrait remplacer la chaine de caractere par $DYN
+# ou quelque chose du genre.
+##########################################################################
+
+         for stri in ` ( sed -e '/^[cC\!]/d' $trufile | sed -n "/\#include/s/\#include//p" | sed 's/\"//g' ; sed -e '/^[cC\!]/d' $trufile | egrep -i '^ *use ' | sed -e 's/,/ /' | awk ' { print $2 } ' ) ` ; do
+            echo $trufile $fili $stri >> create_make_gcm.log
+            strj=`echo $stri | tr [A-Z] [a-z]`
+            str2=""
+            for dirinc in filtrez bibio grid dyn3d $diri $diri/*/ ; do
+# Recherche dans l'ordre hierarchique inverse car seule la derniere
+# ligne est conservee
+               if [ -f $dirinc/$stri ] ; then
+                  str2='$(LIBF)/'$dirinc/$stri
+               elif [ -f $dirinc/$strj ] ; then
+                  str2='$(LIBF)/'$dirinc/$stri
+               elif [ -f $dirinc/$strj.F90 ]  || [ -f $dirinc/$strj.F ]  ; then 
+                  strlib=`echo $dirinc | awk -F/ ' { print $1 } '`
+                  str2='$(LIBO)/lib'$strlib'.a('$strj'.o)'
+               fi
+            done
+            if [ "$str2" = "" ] ; then
+               echo Warn: Include $diri $trufile $fili $stri pas trouve >> $gcm/create_make_gcm.log
+            elif [ "$str2" = "$str1" ] ; then
+               echo Warn: Include $diri $trufile $fili $stri $str1 trouve 2x >> $gcm/create_make_gcm.log
+            else
                echo $str1 \\
-               str1='$(LIBF)/'$diri'/'$stri
-            else
-               if [ -f $stri.F ] || [ -f $stri.F90 ] ; then
-                  echo $str1 \\
-                  str1='$(LIBO)/lib'$diri'.a('$stri'.o)'
-               else
-                  for dirinc in dyn3d grid bibio filtrez
-                  do
-                     if [ -f ../$dirinc/$stri ] ; then
-                        echo $str1 \\
-                        str1='$(LIBF)/'`cd .. ; ls */$stri | head -1`
-                     fi
-                     if [ -f ../$dirinc/$stri.F90 ] ; then
-                        echo $str1 \\
-                        str1='$(LIBO)/lib'$dirinc'.a('$stri'.o)'
-                     fi
-                  done
-               fi
+               str1=$str2
             fi
-         done
+         done # Fin de la boucle sur les dependances et ecriture de la derniere
          echo $str1
          # Compile in LIBO directory; and before compiling, remove
@@ -212,12 +208,12 @@
 	 if [ "$F90" -eq '0' ] ; then
          ## Fixed Form Fortran 77
-	   echo '	$(COMPILE) $(LIBF)/'$diri'/'$trufile' ; \'
+	   echo '	$(COMPILE) $(LIBF)/'$trufile' ; \'
 	 else
          ## Fortran 90
-           if [ -f $fili.F90 ] ; then
+           if [ `echo $trufile | cut -d. -f2` = F90 ] ; then
 	      ## Free Form
-              echo '	$(COMPTRU90) $(LIBF)/'$diri'/'$trufile' ; \'
+              echo '	$(COMPTRU90) $(LIBF)/'$trufile' ; \'
            else
-	      echo '	$(COMPILE90) $(LIBF)/'$diri'/'$trufile' ; \'
+	      echo '	$(COMPILE90) $(LIBF)/'$trufile' ; \'
            fi
 	 fi
Index: LMDZ5/branches/testing/libf/dyn3d/guide_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/guide_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/dyn3d/guide_mod.F90	(revision 1750)
@@ -12,4 +12,5 @@
   USE Write_Field
   use netcdf, only: nf90_nowrite, nf90_open, nf90_inq_varid, nf90_close
+  use pres2lev_mod
 
   IMPLICIT NONE
Index: LMDZ5/branches/testing/libf/dyn3d/pres2lev_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3d/pres2lev_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3d/pres2lev_mod.F90	(revision 1750)
@@ -0,0 +1,80 @@
+! $Id: pres2lev.F 1179 2009-06-11 14:18:47Z jghattas $
+!
+MODULE pres2lev_mod
+
+CONTAINS 
+
+!******************************************************
+SUBROUTINE pres2lev(varo,varn,lmo,lmn,po,pn,ni,nj,ok_invertp)
+!
+! interpolation lineaire pour passer
+! a une nouvelle discretisation verticale pour
+! les variables de GCM
+! Francois Forget (01/1995)
+! MOdif remy roca 12/97 pour passer de pres2sig
+! Modif F.Codron 07/08 po en 3D
+!**********************************************************
+
+  IMPLICIT NONE
+
+!   Declarations:
+! ==============
+!
+!  ARGUMENTS
+!  """""""""
+  LOGICAL, INTENT(IN) :: ok_invertp
+  INTEGER, INTENT(IN) :: lmo ! dimensions ancienne couches
+  INTEGER, INTENT(IN) :: lmn ! dimensions nouvelle couches
+  
+  REAL, INTENT(IN) :: po(ni*nj,lmo) ! niveau de pression ancienne grille
+  REAL, INTENT(IN) :: pn(ni*nj,lmn) ! niveau de pression nouvelle grille
+
+  INTEGER, INTENT(IN) :: ni,nj ! nombre de point horizontal
+
+  REAL, INTENT(IN)  :: varo(ni*nj,lmo) ! var dans l'ancienne grille
+  REAL, INTENT(OUT) :: varn(ni*nj,lmn) ! var dans la nouvelle grille
+
+  REAL :: zvaro(ni*nj,lmo),zpo(ni*nj,lmo)
+
+! Autres variables
+! """"""""""""""""
+  INTEGER ::  ln ,lo, k
+  REAL    :: coef
+
+
+! Inversion de l'ordre des niveaux verticaux
+  IF (ok_invertp) THEN
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lmo+1-lo)
+        zvaro(k,lo)=varo(k,lmo+1-lo)
+      ENDDO
+    ENDDO
+  ELSE
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lo)
+        zvaro(k,lo)=varo(k,lo)
+      ENDDO
+    ENDDO
+  ENDIF 
+
+  DO ln=1,lmn
+    DO lo=1,lmo-1
+      DO k=1,ni*nj
+        IF (pn(k,ln) >= zpo(k,1) ) THEN
+          varn(k,ln) = zvaro(k,1)
+        ELSE IF (pn(k,ln) <= zpo(k,lmo)) THEN
+          varn(k,ln) = zvaro(k,lmo)
+        ELSE IF ( pn(k,ln) <= zpo(k,lo) .AND. pn(k,ln) > zpo(k,lo+1) ) THEN
+          coef = (pn(k,ln)-zpo(k,lo)) / (zpo(k,lo+1)-zpo(k,lo))
+          varn(k,ln) = zvaro(k,lo) + coef*(zvaro(k,lo+1)-zvaro(k,lo))
+        ENDIF
+         
+      ENDDO  
+    ENDDO
+  ENDDO                
+
+END SUBROUTINE pres2lev    
+
+END MODULE pres2lev_mod
Index: LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/dyn3dmem/conf_gcm.F	(revision 1750)
@@ -62,5 +62,9 @@
       LOGICAL  fxyhypbb, ysinuss
       INTEGER i
-      
+      character(len=*),parameter :: modname="conf_gcm"
+      character (len=80) :: abort_message
+#ifdef CPP_OMP
+      integer,external :: OMP_GET_NUM_THREADS
+#endif
 c
 c  -------------------------------------------------------------------
@@ -91,10 +95,4 @@
 c   initialisations:
 c   ----------------
-      adjust=.false.
-      call getin('adjust',adjust)
-      
-      itaumax=0
-      call getin('itaumax',itaumax);
-      if (itaumax<=0) itaumax=HUGE(itaumax)
       
 !Config  Key  = lunout
@@ -109,4 +107,23 @@
      &          STATUS='unknown',FORM='formatted')
       ENDIF
+
+      adjust=.false.
+      call getin('adjust',adjust)
+
+#ifdef CPP_OMP
+      ! adjust=y not implemented in case of OpenMP threads...
+!$OMP PARALLEL
+      if ((OMP_GET_NUM_THREADS()>1).and.adjust) then
+        write(lunout,*)'conf_gcm: Error, adjust should be set to n'
+     &,' when running with OpenMP threads'
+        abort_message = 'Wrong value for adjust'
+        call abort_gcm(modname,abort_message,1)
+      endif
+!$OMP END PARALLEL         
+#endif
+
+      itaumax=0
+      call getin('itaumax',itaumax);
+      if (itaumax<=0) itaumax=HUGE(itaumax)
 
 !Config  Key  = prt_level
Index: LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 1750)
@@ -13,4 +13,5 @@
   use netcdf, only: nf90_nowrite, nf90_open, nf90_inq_varid, nf90_close
   USE parallel
+  USE pres2lev_mod
 
   IMPLICIT NONE
Index: LMDZ5/branches/testing/libf/dyn3dmem/pres2lev_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/pres2lev_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/pres2lev_mod.F90	(revision 1750)
@@ -0,0 +1,80 @@
+! $Id: pres2lev.F 1179 2009-06-11 14:18:47Z jghattas $
+!
+MODULE pres2lev_mod
+
+CONTAINS 
+
+!******************************************************
+SUBROUTINE pres2lev(varo,varn,lmo,lmn,po,pn,ni,nj,ok_invertp)
+!
+! interpolation lineaire pour passer
+! a une nouvelle discretisation verticale pour
+! les variables de GCM
+! Francois Forget (01/1995)
+! MOdif remy roca 12/97 pour passer de pres2sig
+! Modif F.Codron 07/08 po en 3D
+!**********************************************************
+
+  IMPLICIT NONE
+
+!   Declarations:
+! ==============
+!
+!  ARGUMENTS
+!  """""""""
+  LOGICAL, INTENT(IN) :: ok_invertp
+  INTEGER, INTENT(IN) :: lmo ! dimensions ancienne couches
+  INTEGER, INTENT(IN) :: lmn ! dimensions nouvelle couches
+  
+  REAL, INTENT(IN) :: po(ni*nj,lmo) ! niveau de pression ancienne grille
+  REAL, INTENT(IN) :: pn(ni*nj,lmn) ! niveau de pression nouvelle grille
+
+  INTEGER, INTENT(IN) :: ni,nj ! nombre de point horizontal
+
+  REAL, INTENT(IN)  :: varo(ni*nj,lmo) ! var dans l'ancienne grille
+  REAL, INTENT(OUT) :: varn(ni*nj,lmn) ! var dans la nouvelle grille
+
+  REAL :: zvaro(ni*nj,lmo),zpo(ni*nj,lmo)
+
+! Autres variables
+! """"""""""""""""
+  INTEGER ::  ln ,lo, k
+  REAL    :: coef
+
+
+! Inversion de l'ordre des niveaux verticaux
+  IF (ok_invertp) THEN
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lmo+1-lo)
+        zvaro(k,lo)=varo(k,lmo+1-lo)
+      ENDDO
+    ENDDO
+  ELSE
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lo)
+        zvaro(k,lo)=varo(k,lo)
+      ENDDO
+    ENDDO
+  ENDIF 
+
+  DO ln=1,lmn
+    DO lo=1,lmo-1
+      DO k=1,ni*nj
+        IF (pn(k,ln) >= zpo(k,1) ) THEN
+          varn(k,ln) = zvaro(k,1)
+        ELSE IF (pn(k,ln) <= zpo(k,lmo)) THEN
+          varn(k,ln) = zvaro(k,lmo)
+        ELSE IF ( pn(k,ln) <= zpo(k,lo) .AND. pn(k,ln) > zpo(k,lo+1) ) THEN
+          coef = (pn(k,ln)-zpo(k,lo)) / (zpo(k,lo+1)-zpo(k,lo))
+          varn(k,ln) = zvaro(k,lo) + coef*(zvaro(k,lo+1)-zvaro(k,lo))
+        ENDIF
+         
+      ENDDO  
+    ENDDO
+  ENDDO                
+
+END SUBROUTINE pres2lev    
+
+END MODULE pres2lev_mod
Index: LMDZ5/branches/testing/libf/dyn3dpar/conf_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/conf_gcm.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/dyn3dpar/conf_gcm.F	(revision 1750)
@@ -61,5 +61,9 @@
       LOGICAL  fxyhypbb, ysinuss
       INTEGER i
-      
+      character(len=*),parameter :: modname="conf_gcm"
+      character (len=80) :: abort_message
+#ifdef CPP_OMP
+      integer,external :: OMP_GET_NUM_THREADS
+#endif
 c
 c  -------------------------------------------------------------------
@@ -90,10 +94,4 @@
 c   initialisations:
 c   ----------------
-      adjust=.false.
-      call getin('adjust',adjust)
-      
-      itaumax=0
-      call getin('itaumax',itaumax);
-      if (itaumax<=0) itaumax=HUGE(itaumax)
       
 !Config  Key  = lunout
@@ -108,4 +106,23 @@
      &          STATUS='unknown',FORM='formatted')
       ENDIF
+
+      adjust=.false.
+      call getin('adjust',adjust)
+
+#ifdef CPP_OMP
+      ! adjust=y not implemented in case of OpenMP threads...
+!$OMP PARALLEL
+      if ((OMP_GET_NUM_THREADS()>1).and.adjust) then
+        write(lunout,*)'conf_gcm: Error, adjust should be set to n'
+     &,' when running with OpenMP threads'
+        abort_message = 'Wrong value for adjust'
+        call abort_gcm(modname,abort_message,1)
+      endif
+!$OMP END PARALLEL         
+#endif
+
+      itaumax=0
+      call getin('itaumax',itaumax);
+      if (itaumax<=0) itaumax=HUGE(itaumax)
 
 !Config  Key  = prt_level
Index: LMDZ5/branches/testing/libf/dyn3dpar/guide_p_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/guide_p_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/dyn3dpar/guide_p_mod.F90	(revision 1750)
@@ -11,5 +11,6 @@
   USE getparam
   USE Write_Field_p
-  use netcdf, only: nf90_nowrite, nf90_open, nf90_inq_varid, nf90_close
+  USE netcdf, ONLY: nf90_nowrite, nf90_open, nf90_inq_varid, nf90_close
+  USE pres2lev_mod
 
   IMPLICIT NONE
Index: LMDZ5/branches/testing/libf/dyn3dpar/pres2lev_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/pres2lev_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dpar/pres2lev_mod.F90	(revision 1750)
@@ -0,0 +1,80 @@
+! $Id: pres2lev.F 1179 2009-06-11 14:18:47Z jghattas $
+!
+MODULE pres2lev_mod
+
+CONTAINS 
+
+!******************************************************
+SUBROUTINE pres2lev(varo,varn,lmo,lmn,po,pn,ni,nj,ok_invertp)
+!
+! interpolation lineaire pour passer
+! a une nouvelle discretisation verticale pour
+! les variables de GCM
+! Francois Forget (01/1995)
+! MOdif remy roca 12/97 pour passer de pres2sig
+! Modif F.Codron 07/08 po en 3D
+!**********************************************************
+
+  IMPLICIT NONE
+
+!   Declarations:
+! ==============
+!
+!  ARGUMENTS
+!  """""""""
+  LOGICAL, INTENT(IN) :: ok_invertp
+  INTEGER, INTENT(IN) :: lmo ! dimensions ancienne couches
+  INTEGER, INTENT(IN) :: lmn ! dimensions nouvelle couches
+  
+  REAL, INTENT(IN) :: po(ni*nj,lmo) ! niveau de pression ancienne grille
+  REAL, INTENT(IN) :: pn(ni*nj,lmn) ! niveau de pression nouvelle grille
+
+  INTEGER, INTENT(IN) :: ni,nj ! nombre de point horizontal
+
+  REAL, INTENT(IN)  :: varo(ni*nj,lmo) ! var dans l'ancienne grille
+  REAL, INTENT(OUT) :: varn(ni*nj,lmn) ! var dans la nouvelle grille
+
+  REAL :: zvaro(ni*nj,lmo),zpo(ni*nj,lmo)
+
+! Autres variables
+! """"""""""""""""
+  INTEGER ::  ln ,lo, k
+  REAL    :: coef
+
+
+! Inversion de l'ordre des niveaux verticaux
+  IF (ok_invertp) THEN
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lmo+1-lo)
+        zvaro(k,lo)=varo(k,lmo+1-lo)
+      ENDDO
+    ENDDO
+  ELSE
+    DO lo=1,lmo
+      DO k=1,ni*nj
+        zpo(k,lo)=po(k,lo)
+        zvaro(k,lo)=varo(k,lo)
+      ENDDO
+    ENDDO
+  ENDIF 
+
+  DO ln=1,lmn
+    DO lo=1,lmo-1
+      DO k=1,ni*nj
+        IF (pn(k,ln) >= zpo(k,1) ) THEN
+          varn(k,ln) = zvaro(k,1)
+        ELSE IF (pn(k,ln) <= zpo(k,lmo)) THEN
+          varn(k,ln) = zvaro(k,lmo)
+        ELSE IF ( pn(k,ln) <= zpo(k,lo) .AND. pn(k,ln) > zpo(k,lo+1) ) THEN
+          coef = (pn(k,ln)-zpo(k,lo)) / (zpo(k,lo+1)-zpo(k,lo))
+          varn(k,ln) = zvaro(k,lo) + coef*(zvaro(k,lo+1)-zvaro(k,lo))
+        ENDIF
+         
+      ENDDO  
+    ENDDO
+  ENDDO                
+
+END SUBROUTINE pres2lev    
+
+END MODULE pres2lev_mod
Index: LMDZ5/branches/testing/libf/phy1d/lmdz1d.F
===================================================================
--- LMDZ5/branches/testing/libf/phy1d/lmdz1d.F	(revision 1707)
+++ LMDZ5/branches/testing/libf/phy1d/lmdz1d.F	(revision 1750)
@@ -362,5 +362,5 @@
       call infotrac_init 
 
-      allocate(q(llm,nqtot)) 
+      allocate(q(llm,nqtot)) ; q(:,:)=0.
       allocate(dq(llm,nqtot)) 
       allocate(dq_dyn(llm,nqtot)) 
@@ -472,5 +472,5 @@
 
       call iniphysiq(ngrid,llm,rday,day_ini,timestep,
-     .     rlat,rlon,airefi,zcufi,zcvfi,ra,rg,rd,rcpd)
+     .     rlat,rlon,airefi,zcufi,zcvfi,ra,rg,rd,rcpd,1)
       print*,'apres iniphysiq'
 
@@ -674,15 +674,23 @@
 
 !---------------------------------------------------------------------
+! Listing output for debug prt_level>=1
+!---------------------------------------------------------------------
+       if (prt_level>=1) then
+         print *,' avant physiq : -------- day time ',day,time
+         write(*,*) 'firstcall,lastcall,phis',
+     :               firstcall,lastcall,phis
+         write(*,'(a10,2a4,4a13)') 'BEFOR1 IT=','it','l',
+     :        'presniv','plev','play','phi'
+         write(*,'(a10,2i4,4f13.2)') ('BEFOR1 IT= ',it,l,
+     :         presnivs(l),plev(l),play(l),phi(l),l=1,llm)
+         write(*,'(a11,2a4,a11,6a8)') 'BEFOR2','it','l',
+     :         'presniv','u','v','temp','q1','q2','omega2'
+         write(*,'(a11,2i4,f11.2,5f8.2,e10.2)') ('BEFOR2 IT= ',it,l,
+     :   presnivs(l),u(l),v(l),temp(l),q(l,1),q(l,2),omega2(l),l=1,llm)
+       endif
+
+!---------------------------------------------------------------------
 !   Call physiq :
 !---------------------------------------------------------------------
-
-       if (prt_level.ge.1) then
-         print *,' avant physiq : -------- day time ',day,time
-         print *,' temp ',temp
-         print *,' u ',u
-         print *,' q ',q
-         print *,' omega2 ',omega2
-       endif
-!       call writefield_phy('u', u,llm)
 
         call physiq(ngrid,llm,
@@ -693,17 +701,24 @@
      :              du_phys,dv_phys,dt_phys,dq,dpsrf,
      :              dudyn,PVteta)
-!       call writefield_phy('u', u,llm)
-
         firstcall=.false.
-        if (prt_level.ge.1) then
-          print*,'APRES PHYS'
-          print *,' temp ',temp
-          print *,' q ',q
-          print *,' dq ',dq
-          print*,'dq_dyn',dq_dyn
-          print *,' dt_phys ',dt_phys
-          print *,' dpsrf ',dpsrf
-          print *,' dudyn ',dudyn
-          print *,' PVteta',PVteta
+
+!---------------------------------------------------------------------
+! Listing output for debug prt_level>=1
+!---------------------------------------------------------------------
+        if (prt_level>=1) then
+          write(*,'(a11,2a4,4a13)') 'AFTER1 IT=','it','l',
+     :        'presniv','plev','play','phi'
+          write(*,'(a11,2i4,4f13.2)') ('AFTER1 it= ',it,l,
+     :    presnivs(l),plev(l),play(l),phi(l),l=1,llm)
+          write(*,'(a11,2a4,a11,6a8)') 'AFTER2','it','l',
+     :         'presniv','u','v','temp','q1','q2','omega2'
+          write(*,'(a11,2i4,f11.2,5f8.2,e10.2)') ('AFTER2 it= ',it,l,
+     :    presnivs(l),u(l),v(l),temp(l),q(l,1),q(l,2),omega2(l),l=1,llm)
+          write(*,'(a11,2a4,a11,5a8)') 'AFTER3','it','l',
+     :         'presniv','du_phys','dv_phys','dt_phys','dq1','dq2'
+           write(*,'(a11,2i4,f11.2,5f8.2)') ('AFTER3 it= ',it,l,
+     :      presnivs(l),86400*du_phys(l),86400*dv_phys(l),
+     :       86400*dt_phys(l),86400*dq(l,1),dq(l,2),l=1,llm)
+          write(*,*) 'dpsrf',dpsrf
         endif
 !---------------------------------------------------------------------
@@ -711,6 +726,5 @@
 !---------------------------------------------------------------------
 
-      fcoriolis=2.*sin(rpi*xlat/180.)*romega
-
+       fcoriolis=2.*sin(rpi*xlat/180.)*romega
        if (forcing_radconv) then
          fcoriolis=0.0
@@ -721,5 +735,5 @@
 
        if (forcing_toga .or. forcing_GCSSold .or. forcing_twpice) then
-         fcoriolis=0.0
+         fcoriolis=0.0 ; ug=0. ; vg=0.
        endif
          if(forcing_rico) then
@@ -727,5 +741,5 @@
         endif
 
-      print*, 'fcoriolis ', fcoriolis, rlat(1)
+      print*, 'fcoriolis ', fcoriolis, xlat
 
         du_age(1:mxcalc)=
@@ -733,9 +747,5 @@
        dv_age(1:mxcalc)=
      : -fcoriolis*(u(1:mxcalc)-ug(1:mxcalc))
-!         call  writefield_phy('dv_age' ,dv_age,llm)
-!         call  writefield_phy('du_age' ,du_age,llm)
-!         call  writefield_phy('du_phys' ,du_phys,llm)
-!         call  writefield_phy('u_tend' ,u,llm)
-!         call  writefield_phy('u_g' ,ug,llm)
+
         u(1:mxcalc)=u(1:mxcalc) + timestep*(
      :              du_phys(1:mxcalc)
Index: LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 1750)
@@ -11,4 +11,6 @@
   USE aero_mod
   USE phys_local_var_mod, only: absvisaer
+  USE pres2lev_mod
+
 
   !    Yves Balkanski le 12 avril 2006
Index: LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 1750)
@@ -12,4 +12,6 @@
   USE aero_mod
   USE phys_local_var_mod, only: od550aer,od865aer,ec550aer,od550lt1aer
+  USE pres2lev_mod
+
 
   !
